Index: channels/chan_agent.c
===================================================================
--- channels/chan_agent.c	(revision 56340)
+++ channels/chan_agent.c	(working copy)
@@ -793,6 +793,8 @@
 			} else if (!p->loginstart) {
 				p->loginchan[0] = '\0';
 				p->logincallerid[0] = '\0';
+				if (persistent_agents)
+					dump_agents();
 			}
 		} else if (p->dead) {
 			ast_mutex_lock(&p->chan->lock);
@@ -808,6 +810,12 @@
 	/* Only register a device state change if the agent is still logged in */
 	if (p->loginstart)
 		ast_device_state_changed("Agent/%s", p->agent);
+	else {
+		p->loginchan[0] = '\0';
+		p->logincallerid[0] = '\0';
+		if (persistent_agents)
+			dump_agents();
+	}
 
 	if (p->pending) {
 		ast_mutex_lock(&agentlock);
